# IDEA is a patent-encumbered algorithm so default to not supporting it
# To include support for the IDEA algorithm, use: rpmbuild --with IDEA

Summary:	SSH (Secure Shell) client
Name:		perl-Net-SSH-Perl
Version:	1.38
Release:	1%{?dist}
License:	GPL+ or Artistic
Group:		Development/Libraries
Url:		http://search.cpan.org/dist/Net-SSH-Perl/
Source0:	http://search.cpan.org/CPAN/authors/id/T/TU/TURNSTEP/Net-SSH-Perl-%{version}.tar.gz
Source1:	14964AC8.asc
Source2:	161C06B1.asc
Source3:	CD613C9B.asc
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
BuildArch:	noarch
BuildRequires:	perl
BuildRequires:	perl(Carp)
BuildRequires:	perl(Compress::Zlib)
BuildRequires:	perl(Convert::PEM)		>= 0.05
BuildRequires:	perl(Crypt::Blowfish)
BuildRequires:	perl(Crypt::DES)
BuildRequires:	perl(Crypt::DH)			>= 0.01
BuildRequires:	perl(Crypt::DSA)		>= 0.11
BuildRequires:	perl(Crypt::RSA)
BuildRequires:	perl(Digest::BubbleBabble)
BuildRequires:	perl(Digest::HMAC_MD5)
BuildRequires:	perl(Digest::HMAC_SHA1)
BuildRequires:	perl(Digest::MD5)
BuildRequires:	perl(Digest::SHA1)		>= 2.10
BuildRequires:	perl(ExtUtils::MakeMaker)
BuildRequires:	perl(IO::Select)
BuildRequires:	perl(IO::Socket)
BuildRequires:	perl(Math::GMP)			>= 1.04
BuildRequires:	perl(Math::Pari)		>= 2.001804
BuildRequires:	perl(MIME::Base64)
BuildRequires:	perl(Scalar::Util)
BuildRequires:	perl(Socket)
BuildRequires:	perl(String::CRC32)		>= 1.2
BuildRequires:	perl(Test::More)
BuildRequires:	perl(Tie::Handle)
# Additional test coverage
BuildRequires:	perl(Module::Signature)
BuildRequires:	perl(Test::Pod)			>= 0.95
BuildRequires:	perl(Test::Pod::Coverage)	>= 1.04
BuildRequires:	perl(Test::YAML::Meta)		>= 0.03
BuildRequires:	perl(Perl::Critic)
BuildRequires:	perl(Text::SpellChecker), hunspell-en
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
Requires:	perl(Term::ReadKey)

# If building with IDEA support, we need to build with Crypt::IDEA,
# otherwise we need to filter out the dependency on it
%if 0%{?_with_IDEA:1}
BuildRequires:	perl(Crypt::IDEA)
%else
%global __requires_exclude ^perl\\(Crypt::IDEA\\)
%endif

# Make sure the installed package has blowfish support
Requires:	perl(Crypt::Blowfish)

%description
Net::SSH::Perl is an all-Perl module implementing an SSH (Secure Shell)
client. It is compatible with both the SSH-1 and SSH-2 protocols.

%prep
%setup -q -c -n Net-SSH-Perl

# Copy up documentation for convenience with %%doc
cp -a Net-SSH-Perl-%{version}/{Changes,README,LICENSE,eg,ToDo} .

# Avoid extra deps from examples
chmod -c -x eg/*

# Create a GPG directory for testing, to avoid using ~/.gnupg
mkdir --mode=0700 gnupghome
export GNUPGHOME=$(pwd)/gnupghome
gpg --import %{SOURCE1} %{SOURCE2} %{SOURCE3}

# Remove Crypt::IDEA dep if we're not supporting the IDEA algorithm and we don't have rpm 4.9
%define bogusreq 'perl(Crypt::IDEA)'
%global reqfilt /bin/sh -c "%{__perl_requires} | grep -Fvx %{bogusreq}"
%{!?_with_IDEA:%define __perl_requires %{reqfilt}}

%build
cd Net-SSH-Perl-%{version}
(
	# Protocol support (select one)
	# 1=SSH1 2=SSH2 3=Both
	echo 3

	# Algorithm selection (select all required)
	# 1=IDEA 2=DES 3=DES3 4=Blowfish 5=RC4
	echo %{?_with_IDEA:1 }2 3 4 5
) |
perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}
cd -

%install
rm -rf %{buildroot}
make -C Net-SSH-Perl-%{version} pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -exec rm -f {} ';'
%{_fixperms} %{buildroot}

%check
# Critic and POD tests currently fail
export GNUPGHOME=$(pwd)/gnupghome
cd Net-SSH-Perl-%{version}

# Locale set to en_US for spell check tests
LANG=en_US make test \
	TEST_AUTHOR=1 TEST_CRITIC=0 TEST_SIGNATURE=1 TEST_SPELL=0

cd -

%clean
rm -rf %{buildroot}

%files
%if 0%{?_licensedir:1}
%license LICENSE
%else
%doc LICENSE
%endif
%doc Changes README eg ToDo
%{perl_vendorlib}/Net/
%{_mandir}/man3/Net::SSH::Perl*.3pm*

%changelog
* Thu Oct  9 2014 Paul Howarth <paul@city-fan.org> - 1.38-1
- Update to 1.38
  - Install valid SIGNATURE file (CPAN RT#99284)
- Re-enable the signature test
- This release by TURNSTEP → update source URL
- Use %%license where possible

* Fri Aug 29 2014 Jitka Plesnikova <jplesnik@redhat.com> - 1.37-3
- Perl 5.20 rebuild

* Sat Jun 07 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.37-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Sun Mar 30 2014 Paul Howarth <paul@city-fan.org> - 1.37-1
- Update to 1.37
  - Enabled config option "StrictHostKeyChecking"; the corresponding code
    already existed (CPAN RT#91840)
- Don't test signature because upstream forgot to re-generate it

* Sat Aug 10 2013 Paul Howarth <paul@city-fan.org> - 1.36-1
- Update to 1.36
  - CPAN RT#48338 - Fix race condition with SSHv2
  - CPAN RT#55195 - Fix race condition in KEXINIT
  - CPAN RT#67586 - Fix test '03-packet.t' hangs forever
  - CPAN RT#64517 - Enable PTY support in SSH2
  - CPAN RT#23947 - Replacement for KeyboardInt.pm
- Drop %%defattr, redundant since rpm 4.4
- Disable spell check test, which simplifies the spec considerably

* Sat Aug 03 2013 Petr Pisar <ppisar@redhat.com> - 1.35-3
- Perl 5.18 rebuild

* Thu Feb 14 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.35-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Mon Dec  3 2012 Paul Howarth <paul@city-fan.org> 1.35-1
- Update to 1.35
  - Apply patch to t/03-packet.t for 5.15+ (CPAN RT#76482)
- This release by SCHWIGON -> update source URL
- Drop upstreamed patch for CPAN RT#76482

* Fri Jul 20 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.34-17
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Mon Jul  2 2012 Paul Howarth <paul@city-fan.org> 1.34-16
- Fix breakage with Perl 5.16 (CPAN RT#76482)
- Drop buildreqs for modules that are not dual-lived
- Don't need to remove empty directories from the buildroot

* Mon Jul 02 2012 Petr Pisar <ppisar@redhat.com> - 1.34-15
- Perl 5.16 rebuild

* Thu Jan 12 2012 Paul Howarth <paul@city-fan.org> 1.34-14
- Use DESTDIR rather than PERL_INSTALL_ROOT
- Use %%{_fixperms} macro rather than our own chmod incantation
- Add buildreqs not mentioned in module metadata

* Wed Jul 20 2011 Paul Howarth <paul@city-fan.org> 1.34-13
- Perl mass rebuild
- Work around MYMETA.yml causing signature test to fail
- Use LANG rather than LC_ALL to set locale for spell check test

* Thu Jun 23 2011 Paul Howarth <paul@city-fan.org> 1.34-12
- Nobody else likes macros for commands
- Update fix for spell check test again

* Sat Feb 12 2011 Paul Howarth <paul@city-fan.org> 1.34-11
- Fix dependency filtering for Crypt::IDEA in rpm 4.9

* Wed Feb  9 2011 Paul Howarth <paul@city-fan.org> 1.34-10
- Update fix for spell check test as dictionary coverage in Rawhide appears
  to have gone down

* Tue Feb 08 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.34-9
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Mon Oct  4 2010 Paul Howarth <paul@city-fan.org> 1.34-8
- BR: hunspell-en rather than aspell-en now that Text::SpellChecker uses a
  hunspell back-end
- Fix spell check test to add words not in hunspell dictionary

* Thu May 13 2010 Paul Howarth <paul@city-fan.org> 1.34-7
- Don't clobber ~/.gnupg during build

* Tue May 04 2010 Marcela Maslanova <mmaslano@redhat.com> - 1.34-6
- Mass rebuild with perl-5.12.0

* Mon Dec  7 2009 Stepan Kasal <skasal@redhat.com> - 1.34-5
- Rebuild against perl 5.10.1

* Sun Jul 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.34-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Thu Feb 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.34-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Sun Feb 22 2009 Paul Howarth <paul@city-fan.org> 1.34-2
- Add buildreq aspell-en for spell check test

* Mon Feb  2 2009 Paul Howarth <paul@city-fan.org> 1.34-1
- Update to 1.34, fixes various upstream bugs:
  * Rekey properly after 1 GB of data (rt.cpan.org #25044)
  * Don't try to process nonexistent or empty auth file (rt.cpan.org #41877)
  * Fix typo in croak message (rt.cpan.org #42056)
  * Move 'use base' call after Crypt module loading (rt.cpan.org #42051)
  * Only apply stdin if defined in SSH1 (rt.cpan.org #42583)

* Tue Nov  4 2008 Paul Howarth <paul@city-fan.org> 1.33-2
- Run tests in en_US locale, so spell checker doesn't complain about the use of
  American English when the host is in a non-US locale

* Mon Nov  3 2008 Paul Howarth <paul@city-fan.org> 1.33-1
- Update to 1.33 (#469612), fixes various upstream bugs:
  * Fix open() calls (rt.cpan.org #40020)
  * Fix non-shell problem (rt.cpan.org #39980)
  * Allow full agent forwarding (rt.cpan.org #32190)
  * Handle hashed known_hosts files (rt.cpan.org #25175)
  * Add IO::Handle to Perl.pm (rt.cpan.org #40057, #35985)
  * Prevent t/03-packet.t from hanging due to high file descriptor
  | (rt.cpan.org #6101)
  * If ENV{HOME} is not set, use getpwuid. If both fail and the dir 
  | is needed, we croak (rt.cpan.org #25174)
  * Fix incorrect logical/bitwise AND mixup (rt.cpan.org #31490)
  * Allow empty stdin for SSH2 (rt.cpan.org #32730)
  * Adjust terminal dimensions dynamically if Term::ReadKey is available
  | (rt.cpan.org #34874)
- New upstream (co-)maintainer, new source URL
- t/03-packet.t re-enabled as it should no longer hang
- Add buildreqs Module::Signature, Test::Pod, Test::Pod::Coverage,
  Perl::Critic, Test::YAML::Meta, Text::SpellChecker for additional test
  coverage
- Add dependency on Term::ReadKey to provide dynamic terminal resizing
- Include upstream maintainer's GPG key for signature checking

* Thu Mar  6 2008 Tom "spot" Callaway <tcallawa@redhat.com> 1.30-6
- Rebuild for new perl

* Mon Aug 13 2007 Paul Howarth <paul@city-fan.org> 1.30-5
- Clarify license as GPL v1 or later, or Artistic (same as perl)
- Add buildreq perl(Test::More)

* Wed Apr 18 2007 Paul Howarth <paul@city-fan.org> 1.30-4
- Buildrequire perl(ExtUtils::MakeMaker)
- Fix argument order for find with -depth

* Wed Aug 30 2006 Paul Howarth <paul@city-fan.org> 1.30-3
- Skip test 03-packet, which can sometimes hang (cpan rt#6101)
- Add manual Crypt::Blowfish dep to ensure we have blowfish support

* Wed Aug 30 2006 Paul Howarth <paul@city-fan.org> 1.30-2
- FE6 mass rebuild

* Mon Mar 20 2006 Paul Howarth <paul@city-fan.org> 1.30-1
- Update to 1.30
- Patch for cpan rt#11674 no longer needed, fixed upstream

* Thu Mar  2 2006 Paul Howarth <paul@city-fan.org> 1.29-1
- Initial build
